/*
 * SPDX-FileCopyrightText: 2012-2018 Bruce Cowan <bruce@bcowan.me.uk>
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#pragma once

#include <gio/gio.h>

G_BEGIN_DECLS

typedef enum
{
    GLOB_SEARCH_TOO_MANY_RESULTS
} GlobSearchError;

#define GLOB_SEARCH_ERROR glob_search_error_quark ()
GQuark glob_search_error_quark (void);

#define GLOB_TYPE_SEARCH glob_search_get_type ()
G_DECLARE_FINAL_TYPE (GlobSearch, glob_search, GLOB, SEARCH, GObject)

GlobSearch * glob_search_new                (void);

void         glob_search_get_matches        (GlobSearch          *search,
                                             const char          *pattern,
                                             GCancellable        *cancellable,
                                             GAsyncReadyCallback  callback,
                                             gpointer             user_data);
GListModel * glob_search_get_matches_finish (GlobSearch          *search,
                                             GAsyncResult        *res,
                                             GError             **err);

G_END_DECLS
